from enum import Enum

class Direction(Enum):
    GAUCHE = 0
    DROITE = 2
    HAUT = 1
    BAS = 3

class Robot:
    "Classe Robot - LEnsE / VILLEMEJANE (c) 2020"

    def __init__(self):
        self.posX = 0
        self.oldPosX = 0
        self.posY = 0
        self.oldPosY = 0
        self.direction = Direction.BAS;

    def __init__(self, x, y):
        self.oldPosX = x
        self.posX = x
        self.oldPosY = y
        self.posY = y
        self.direction = Direction.BAS

    def afficher(self):
        print('Affichage Robot - X = ' + str(self.posX) + ' / Y = ' + str(self.posY) + ' / DIR = ' + str(self.direction))
    
    def tournerGauche(self):
        if(self.direction == Direction.BAS):
            self.direction = Direction.DROITE
        elif(self.direction == Direction.DROITE):
            self.direction = Direction.HAUT
        elif(self.direction == Direction.HAUT):
            self.direction = Direction.GAUCHE
        else:
            self.direction = Direction.BAS
        print('Gauche')
        self.afficher()

    def tournerDroite(self):
        if(self.direction == Direction.BAS):
            self.direction = Direction.GAUCHE
        elif(self.direction == Direction.DROITE):
            self.direction = Direction.BAS
        elif(self.direction == Direction.HAUT):
            self.direction = Direction.DROITE
        else:
            self.direction = Direction.HAUT
        print('Droite')
        self.afficher()
        
    def avancer(self) :
        self.oldPosX = self.posX
        self.oldPosY = self.posY
        if(self.direction == Direction.BAS):
            self.posY += 1
        elif(self.direction == Direction.DROITE):
            self.posX += 1
        elif(self.direction == Direction.HAUT):
            self.posY -= 1
        else:
            self.posX -= 1   
        print('Avancer')
        self.afficher()   
        
    def getDirection(self):
        return self.direction
    def getPosX(self):
        return self.posX
    def getPosY(self):
        return self.posY
    def getOldPosX(self):
        return self.oldPosX
    def getOldPosY(self):
        return self.oldPosY