# mettre la case de départ d'une couleur différente
# mettre les cases traversées d'une autre couleur
# faire une case qui efface toute la ligne de commande
# reprendre de l'endroit d'arrivée temporaire plutot que du départ
# reinitialiser les obstacles
# initialiser aléatoirement départ / arrivée


from tkinter import *
from PIL import ImageTk, Image
from time import sleep
from random import *

nbLignes = 10
nbColonnes = 10
taille = 500
ligneDepart=0
colonneDepart=0
ligneArrivee=0
colonneArrivee=0
nbreacquis=0
listeobstacles = []


fenetre = Tk()
fenetre.title("apprentissage de la programmation")

platforme = Canvas(fenetre, width = taille, heigh = taille) #création d'un espace de dessin de 505 pixels par 505 pixels
platforme.create_rectangle(0, 0, taille,taille,fill ='white', width =0)
platforme.grid(column = 0,row = 0) # position de la fenêtre 

commande = Frame(fenetre)
commande.grid(column = 1, row = 0) #positionnement de l'espace commande à droite du damier : on gère les objets les uns par rapport aux autres 


robotimage = PhotoImage(file='robot_cool_small.gif',master=fenetre) 
drapeau = PhotoImage(file='drapeau_small.gif',master=fenetre) 

def creergrille(ligneRobot, colonneRobot):
    platforme.delete(ALL)
    n = taille/nbLignes
    for i in range (nbLignes):
        for j in range(nbColonnes) :
            platforme.create_rectangle(i*n,j*n,i*n+n,j*n+n)
    robot = [ligneRobot*50,colonneRobot*50]
    platforme.create_image(robot[1],robot[0], anchor = NW, image=robotimage)
    platforme.update()
creergrille(0,0)

def creergrille1(ligneRobot, colonneRobot):
    global robot
    platforme.delete(ALL)
    n = taille/nbLignes
    for i in range (nbLignes):
        for j in range(nbColonnes) :
            platforme.create_rectangle(i*n,j*n,i*n+n,j*n+n)
    robot = [ligneRobot*50,colonneRobot*50]
    platforme.create_image(robot[1],robot[0], anchor = NW, image=robotimage)
    platforme.create_image(colonneArrivee*50,ligneArrivee*50, anchor = NW, image=drapeau)
    platforme.update()

def creergrille2(ligneRobot, colonneRobot):
    global robot, listeobstacles
    platforme.delete(ALL)
    n = taille/nbLignes
    for i in range (nbLignes):
        for j in range(nbColonnes) :
            platforme.create_rectangle(i*n,j*n,i*n+n,j*n+n)
    for i in range(len(listeobstacles)):
        platforme.create_oval(listeobstacles[i][0]*50,listeobstacles[i][1]*50,listeobstacles[i][0]*50+50,listeobstacles[i][1]*50+50,fill='black')
    robot = [ligneRobot*50,colonneRobot*50]
    platforme.create_image(robot[1],robot[0], anchor = NW, image=robotimage)
    platforme.create_image(colonneArrivee*50,ligneArrivee*50, anchor = NW, image=drapeau)
    platforme.update()

autresboutons = Frame(commande)
autresboutons.grid(column = 1, row = 0)


def coordonneeArrivee(l2,c2):
    global ligneArrivee, colonneArrivee, creergrille
    ligneArrivee=l2
    colonneArrivee=c2
    positionfin.destroy()
    creergrille = creergrille1
    creergrille(ligneDepart, colonneDepart)

            
def positionarrivee(*arg):#définition grille pour séléctionner position d'arrivée
    global positionfin
    positionfin = Frame(boutonDeplacement)
    positionfin.grid(column = 4, row = 5)
    global nbLignes 
    global nbColonnes
    for ligne in range (nbLignes):
        for colonne in range (nbColonnes):
            exec("Button(positionfin, text='L%s-C%s' % ({}, {}), borderwidth=1,command=lambda:coordonneeArrivee({}, {})).grid(row={}+3, column={}+3)".format(ligne, colonne,ligne, colonne,ligne, colonne))



def coordonneeDepart(l1,c1):
    global ligneDepart, colonneDepart
    ligneDepart=l1
    colonneDepart=c1
    position.destroy()
    creergrille(l1,c1)
    
def positiondepart(*arg):#définition grille pour séléctionner position d'arrivée
    global position
    position = Frame(boutonDeplacement)
    position.grid(column = 4, row = 5)
    global nbLignes 
    global nbColonnes
    for ligne in range (nbLignes):
        for colonne in range (nbColonnes):
            exec("Button(position, text='L%s-C%s' % ({}, {}), borderwidth=1,command=lambda:coordonneeDepart({}, {})).grid(row={}+3, column={}+3)".format(ligne, colonne,ligne, colonne,ligne, colonne))    
    

def cheminlepluscourt(*arg):
    pass

#nouvelle fonction : place le nombre d'obstacles voulus  
def placerobst(*arg):
    global creergrille
    nbreacquis = int(s.get())#récup valeur dans liste déroulement
    for i in range (nbreacquis):
        obstaclesaleatoires()
    creergrille = creergrille2


listeobstacles=[] #liste qui contiendra les positions des obstacles en pixels
listecases=[] #liste qui contient les cases du damier    
n = taille/nbLignes 
for i in range (nbLignes):#remplissagedelaliste
    for j in range (nbColonnes):
        listecases.append([i,j])

def obstaclesaleatoires():
    global listeobstacles, listecases,n
    casealeat=choice(listecases)#on choisit une case aléatoirement et on la stocke dans listeobstacles
    if (casealeat[0]*50==robot[1] and casealeat[1]*50==robot[0]) or (casealeat[1]*50==ligneArrivee*50 and casealeat[0]==colonneArrivee):
        return
    listeobstacles.append(casealeat)#stockés "4 par 4" mais une seule liste
    platforme.create_oval(casealeat[0]*50,casealeat[1]*50,casealeat[0]*50+50,casealeat[1]*50+50,fill='black')#0=côté gauche, 1=haut, 2=côté droit, 3=bas
    
def entrerObstacle(*arg):
    global creergrille, listeobstacles, ligneDepart,colonneDepart
    n=taille//nbLignes
    ichoisi= int(sligne.get())#récupère valeur de la ligne choisie
    jchoisi=int(scolonne.get())#récupère valeur de la colonne choisie
    listeobstacles.append([jchoisi-1,ichoisi-1])
    #platforme.create_oval(jchoisi*n-n, ichoisi*n-n, jchoisi*n, ichoisi*n, fill='green')#crée l'obstacle correspondant
    creergrille = creergrille2
    creergrille(ligneDepart,colonneDepart)

Button(autresboutons,text = "position de départ",command = positiondepart).grid(column = 0, row = 0)
Button(autresboutons,text = "position d'arrivée",command = positionarrivee).grid(column = 1, row = 0)
Button(autresboutons,text = "chemin le plus court",command = cheminlepluscourt).grid(column = 0, row = 1)


#création des fenêtres de déroulement
s = Spinbox(autresboutons, from_=0, to=10)
s.grid(column=0, row=4)
stitre=Label(autresboutons, text="nbre obstacles")
stitre.grid(column=1, row=4)
Button(autresboutons,text = "Lancer placer obstacles",command =placerobst).grid(column=0,row=5) #bouton validation

sligne = Spinbox(autresboutons, from_=0, to=10)
sligne.grid(column=0, row=6)
slignetitre=Label(autresboutons, text='ligne obstacle')
slignetitre.grid(column=1, row=6)
scolonne = Spinbox(autresboutons, from_=0, to=10)
scolonne.grid(column=0, row=7)
scolonnetitre=Label(autresboutons, text='colonne obstacle')
scolonnetitre.grid(column=1, row=7)
Button(autresboutons,text = "entrer un obstacle",command = entrerObstacle).grid(column = 0, row = 8)


chemin = ""
cheminbis = []

def deplacementhaut(*arg):
    global chemin, cheminbis
    chemin += "↑"
    cheminbis.append(8)
    sv.set(chemin)
def deplacementbas(*arg):
    global chemin, cheminbis
    chemin += "↓"
    cheminbis.append(2)
    sv.set(chemin)
def deplacementdroite(*arg):
    global chemin, cheminbis
    chemin += "→"
    cheminbis.append(6)
    sv.set(chemin)
def deplacementgauche(*arg):
    global chemin, cheminbis
    chemin += "←"
    cheminbis.append(4)
    sv.set(chemin)
def findeplacement(*arg):
    global chemin, cheminbis
    chemin = chemin[:-1]
    cheminbis = cheminbis[:-1]
    sv.set(chemin)
def lancerDeplacement(*arg):
    global chemin,cheminbis
    chemin = ''
    sv.set(chemin)
    robot=[ligneDepart,colonneDepart]
    creergrille(robot[0],robot[1])
    for i in range (len(cheminbis)) :
        if cheminbis[i]==2:
            robot[0]+=1
            chemin += '↓'
            sv.set(chemin)
        elif cheminbis[i] == 6:
            robot[1]+=1
            chemin += '→'
            sv.set(chemin)
        elif cheminbis[i] == 4:
            robot[1] -=1
            chemin += '←'
            sv.set(chemin)
        elif cheminbis[i]==8:
            robot[0] -= 1
            chemin += '↑'
            sv.set(chemin)
        if not 0<= robot[0] <=nbColonnes or not 0<= robot[1] <=nbLignes:
            print ('le robot est sortie du damier')
            return
        for i in range(len(listeobstacles)):
            if listeobstacles[i][0]==robot[1] and listeobstacles[i][1] == robot[0]:
                print('le robot ne peut pas aller sur cette case')
                return
        if robot[0]==ligneArrivee and robot[1]==colonneArrivee:
            print('vous êtes arrivés à destination !')
            return
        sleep(0.3)
        creergrille(robot[0],robot[1])
        
        
            


boutonDeplacement = Frame(commande)
boutonDeplacement.grid(column = 0, row = 0)

Button(boutonDeplacement,text = "↑",command = deplacementhaut).grid(column = 1, row = 0)
Button(boutonDeplacement,text = "→",command = deplacementdroite).grid(column = 2, row = 1)
Button(boutonDeplacement,text = "←",command = deplacementgauche).grid(column = 0, row = 1)
Button(boutonDeplacement,text = "↓",command = deplacementbas).grid(column = 1, row = 2)
Button(boutonDeplacement,text = "Effacer",command = findeplacement).grid(column = 1, row = 1)
Button(boutonDeplacement,text = "OK",command = lancerDeplacement).grid(column = 3, row = 1)

sv = StringVar()
l = Label(boutonDeplacement,textvariable=sv)
l.grid(row = 3,columnspan=3)


fenetre.mainloop() #clore la création et être en mode réception 